import tensorflow as tf
import numpy as np
import LoadFeatureData

class LoadTensorData:
    """ A simple class for converting feature data into tensor data. """

    rows = []
    answers = []
    rowCount = 0

    train = []
    trainAnswers = []
    trainCount = 0;

    validate = []
    validateANswers = []
    validateCount = 0

    verbose = False
    loadFeatureData = None

    columnMap = []
    dataModelColCount = 0
    dataModelAnsColCount = 0

    trainPrct = 0.70
    validatePrct = 0.30

    def __init__(self, lVerbose=False, lTrainPrct=0.70, lValidatePrct=0.30, lLoadFeatureData=None):
        self.verbose = lVerbose
        self.trainPrct = lTrainPrct
        self.validatePrct = lValidatePrct
        self.loadFeatureData = lLoadFeatureData
    #edef

    def generateData(self, lColumnMap=[]):
        print ("")
        print ("")
        print("Generating Tensor Data:")

        self.resetRows()
        self.columnMap = lColumnMap
        self.dataModelColCount = len(self.columnMap)
        self.dataModelAnsColCount = 2  # category yes, category no

        # Prep training date
        tp = int(self.loadFeatureData.rowCount * self.trainPrct)
        vp = int(self.loadFeatureData.rowCount * self.validatePrct)

        # Convert base data
        val2 = []
        val3 = []
        rowcnt = 0
        for row in self.loadFeatureData.rows:
            val = []
            for col in self.columnMap:
                val.append(float(row.getMemberByName(col)))
            # efl
            val2.append(val)

            val4 = []
            val4.append(float(row.getMemberByName('AnswerCatYes')))
            val4.append(float(row.getMemberByName('AnswerCatNo')))
            val3.append(val4)

            rowcnt += 1
        # efl

        self.rows = tf.to_float(val2)
        self.answers = tf.to_float(val3)
        self.rowCount = rowcnt

        print("TensorRow Answer Shape: %s" % self.answers.get_shape())
        print("TensorRow Data Shape: %s" % self.rows.get_shape())
        print('TensorRow Count: %i' % (self.rowCount))

        # Convert train data
        val2 = []
        val3 = []
        rowcnt = 0
        rc = 0
        for row in self.loadFeatureData.rows:
            if rowcnt < tp:
                val = []
                for col in self.columnMap:
                    val.append(float(row.getMemberByName(col)))
                # efl
                val2.append(val)

                val4 = []
                val4.append(float(row.getMemberByName('AnswerCatYes')))
                val4.append(float(row.getMemberByName('AnswerCatNo')))
                val3.append(val4)
                rc += 1
            # eif
            rowcnt += 1
        # efl

        self.train = tf.to_float(val2)
        self.trainAnswers = tf.to_float(val3)
        self.trainCount = rc

        print("TensorTrain Answer Shape: %s" % self.trainAnswers.get_shape())
        print("TensorTrain Data Shape: %s" % self.train.get_shape())
        print('TensorTrain Count: %i' % (self.trainCount))

        # Convert validate data
        val2 = []
        val3 = []
        rowcnt = 0
        rc = 0
        for row in self.loadFeatureData.rows:
            if rowcnt > tp and rowcnt < (tp + vp):
                val = []
                for col in self.columnMap:
                    val.append(float(row.getMemberByName(col)))
                # efl
                val2.append(val)

                val4 = []
                val4.append(float(row.getMemberByName('AnswerCatYes')))
                val4.append(float(row.getMemberByName('AnswerCatNo')))
                val3.append(val4)
                rc += 1
            # eif
            rowcnt += 1
        # efl

        self.validate = tf.to_float(val2)
        self.validateAnswers = tf.to_float(val3)
        self.validateCount = rc

        print("TensorValidate Answer Shape: %s" % self.validateAnswers.get_shape())
        print("TensorValidate Data Shape: %s" % self.validate.get_shape())
        print('TensorValidate Count: %i' % (self.validateCount))

    # edef

    def resetRows(self):
        self.rows = []
        self.answers = []
        self.rowCount = 0

        self.train = []
        self.trainAnswers = []
        self.trainCount = 0;

        self.validate = []
        self.validateAnswers = []
        self.validateCount = 0
    # edef

# eclass

